; Datenformat wandeln, Rechenprogramme

.global Div32d16ist32,Bin17asc5,Bin16asc3
.include "allgdef.inc"

; W5,w4 durch W6 = W3,w2, der hhere Wert ist im hheren Register, nur pos.Werte 
; 41 Cycle x 34ns = ca. 1,4us
; Register: W0 bis W6

Div32d16ist32:
	clr		w2
	cp0		w6
	bra		nz,div0
	mov		#0xffff,w3
	mov		#0xffff,w2
	return
div0:
	repeat	#17
	div.u	w5,w6			; w5 : w6 = w0, rest w1
	mov		w0,w3 
	mov		w1,w5
	repeat	#17		
	div.ud	w4,w6			; w5,w4 : w6 = w0, rest in w1
	add		w0,w2,w2
	clr		w0
	addc	w0,w3,w3
	return
	
; 17bit bin nach 5 Byte ASCII max. 99999
; Eingang: w3,w2 Ausgang: w4,w3,w2,w1,w0

Bin17asc5:
	mov		#10000,w6
;	mov		w0,w4
;	mov		w1,w5
	repeat	#17
	div.ud	w2,w6		; w5,w4 : w6 = w0, rest in w1
	mov		w0,w4		; 5.Stelle (HW)
	ior		#0x30,w4
	mov		w1,w5
	mov		#1000,w6
	repeat	#17
	div.u	w5,w6		; w5 : w6 = w0, rest in w1
	mov		w0,w3   	; 4.Stelle
	ior		#0x30,w3
	mov		w1,w5
	mov		#100,w6
	repeat	#17
	div.u	w5,w6		; w5 : w6 = w0, rest in w1
	mov		w0,w2		; 3. Stelle
	ior		#0x30,w2
	mov		w1,w5
	mov		#10,w6
	repeat	#17
	div.u	w5,w6		; w5 : w6 = w0, rest in w1
	exch	w1,w0		; 2. und 1. Stelle
	ior		#0x30,w0
	ior		#0x30,w1
	return

; 16bit bin nach 5 Byte ASCII max. 32767
; Eingang: w0, Ausgang: w4,w3,w2,w1,w0

Bin16asc5:
	mov		#10000,w6
	mov		w0,w5
	repeat	#17
	div.u	w5,w6		; w5 : w6 = w0, rest in w1
	mov		w0,w4		; 5.Stelle (HW)
	ior		#0x30,w4
	mov		w1,w5
	mov		#1000,w6
	repeat	#17
	div.u	w5,w6		; w5 : w6 = w0, rest in w1
	mov		w0,w3   	; 4.Stelle
	ior		#0x30,w3
	mov		w1,w5
	mov		#100,w6
	repeat	#17
	div.u	w5,w6		; w5 : w6 = w0, rest in w1
	mov		w0,w2		; 3. Stelle
	ior		#0x30,w2
	mov		w1,w5
	mov		#10,w6
	repeat	#17
 	div.u	w5,w6		; w5 : w6 = w0, rest in w1
	exch	w1,w0		; 2. und 1. Stelle
	ior		#0x30,w0
	ior		#0x30,w1
	return

; 16bit bin nach 3 Byte ASCII max. 999
; Eingang: w0, Ausgang: w2,w1,w0
Bin16asc3:
	mov		#100,w6
	mov		w0,w5
	repeat	#17
	div.u	w5,w6		; w5 : w6 = w0, rest in w1
	mov		w0,w2		; 3. Stelle
	ior		#0x30,w2
	mov		w1,w5
	mov		#10,w6
	repeat	#17
 	div.u	w5,w6		; w5 : w6 = w0, rest in w1
	exch	w1,w0		; 2. und 1. Stelle
	ior		#0x30,w0
	ior		#0x30,w1
	return
	